window.addEventListener('load', () => {

    window.addEventListener("message", (event) => {
        if (event.data.type == "markerupdate") {
            updateTable(event.data.data);
        }
    }, false);


    document.querySelector('#mi_trash').addEventListener('click', () => {
        document.querySelector('#main').innerHTML = '';
    })

})


function sendMessage(json) {
    parent.postMessage(json, "*");
}

function sendHighlightRangeRequest(range) {
    sendMessage({
        type: 'highlightrangerequest',
        data: range
    })
}

function updateTable(markers) {

    html = '<table class="table table-hover table-sm">';
    html += '  <thead>';
    html += '    <tr>';
    html += '      <th scope="col">Code</th>';
    html += '      <th scope="col">Quelle</th>';
    html += '      <th scope="col">Fehlermeldung</th>';
    html += '      <th scope="col">Fehlerstelle</th>';
    html += '      <th scope="col">Gewicht</th>';
    html += '    </tr>';
    html += '  </thead>';
    html += '  <tbody>';

    markers.map(marker => {
        let trclass = "";
        if(marker.owner == 'typescript') {
            trclass = "table-danger";
            if(marker.severity <= 1) {
                trclass = "table-warning";
            }
        } else if(marker.owner == 'css') {
            trclass = "table-warning";
        }

        html += '    <tr class="' + trclass + '" data-range="' + marker.startLineNumber + "," + marker.startColumn + "," + marker.endLineNumber + "," + marker.endColumn + '">';
        html += '      <td>' + marker.code +'</td>';
        html += '      <td>' + marker.owner +'</td>';
        html += '      <td>' + marker.message +'</td>';
        html += '      <td>Zeile ' + marker.startLineNumber +', Spalte ' + marker.startColumn + '</td>';
        html += '      <td style="text-align: right;">' + marker.severity +'</td>';
        html += '    </tr>';
        
    })

    html += '  </tbody>';
    html += '</table>';

    document.querySelector('#main').innerHTML = html;

    document.querySelectorAll('[data-range]').forEach(item  => {
        item.addEventListener('click', () => {
            const range = item.getAttribute("data-range");
            sendHighlightRangeRequest(range);
        })
    }) 

}