
window.addEventListener('load', () => {

    window.addEventListener("message", (event) => {

        if (event.data.type == 'projectnamechanged') {
            sendGuiReloadRequest();
        } else if (event.data.type == "htmlmodified") {
            document.querySelector('#main').innerHTML = event.data.data;
        } else if (event.data.type == "cssmodified") {
            document.querySelector('#userstyle').innerText = event.data.data;
        } else if (event.data.type == "run") {
            //document.querySelector('#userscript').textContent = event.data.data;
            eval(event.data.data);
        } else if (event.data.type == "run2") {
            //document.querySelector('#userscript').textContent = event.data.data;
            //document.querySelector('#main').innerHTML = event.data.data.html;

            document.querySelectorAll('[data-scripttype]').forEach((ele) => {
                ele.remove();
            })

            var s0 = document.getElementById('main');
            var g = document.createElement('script');
            g.setAttribute('data-scripttype', 'user');
            var s = document.getElementsByTagName('script')[0];
            g.text = event.data.data.js;
            s0.append(g);
        }

    }, false);


    sendMessage = (json) => {
        parent.postMessage(json, "*");
    }



    document.querySelector('#mi_reload').addEventListener('click', () => {
        sendGuiReloadRequest();
    })

})

function sendGuiReloadRequest() {
    sendMessage({
        type: 'guireloadrequest',
        data: ''
    })
    location.reload()
    //document.querySelector('#main').innerHTML  = document.querySelector('#main').innerHTML;
}


console.clear = function () {
    sendMessage({
        type: 'clearlog',
        data: ''
    })
}

console.log = function (txt) {
    myconsole(txt)
}

console.info = function (txt) {
    myconsole(txt, 'blue')
}

myconsole = function (txt, color='black') {
    let tooltip = "-";
    let title = "Typ: <span style='color: blue'>" + typeof txt + "</span>";

    if (Array.isArray(txt)) {
        tooltip = "<table style='font-size: 0.8em;'>";
        tooltip += '<caption style="caption-side: top; margin-left: 16px; font-style: italic; font-size: 0.8em; color: blue;">' + Object.keys({ txt })[0] + '</caption>';
        tooltip += "<tr style='text-align: center;'>";
        for (let i = 0; i < txt.length; i++) {
            tooltip += "<td style='width: 28px; border: 1px solid #ccc; padding: 2px;'>" + txt[i] + "</td>";
        }
        tooltip += "<tr>";
        tooltip += "<tr style='font-size: 0.8em; color: #ccc; text-align: center;'>";
        for (let i = 0; i < txt.length; i++) {
            tooltip += "<td style='border: 1px solid #ccc; padding: 2px;'>" + i + "</td>";
        }
        tooltip += "<tr>";
        tooltip += "</table>";

        title = "Typ: <span style='color: blue'>Array</span> der Länge " + txt.length;
    } else if (typeof txt == "string") {
        tooltip = "Länge: " + txt.length + " Zeichen";
    } else if (typeof txt == "number") {
        tooltip = Number.isInteger(txt) ? 'Ganze Zahl' : 'Dezimalzahl';
    } else if (txt instanceof Date) {
        title = "Typ: <span style='color: blue'>Date</span>";
        let d = new Date(txt);
        tooltip = "Datum:&nbsp;" + d.toLocaleDateString()
        tooltip += "<br>Uhrzeit:&nbsp;" + d.toLocaleTimeString()
    } else if (txt instanceof Object) {
        tooltip = "<div style='margin-bottom: 12px;text-decoration: underline;'>Objekteigenschaften:</div>";
        for (const [key, value] of Object.entries(txt)) {
            tooltip += (`${key} = ${value}&nbsp;&nbsp;&nbsp;(${typeof value})<br>`);
        }
    } else {
        tooltip = "-";
    }

    sendMessage({
        type: 'log',
        data: {
            'txt': JSON.stringify(txt),
            'tooltip': tooltip,
            'title': title,
            'color': color
        }
    })
}


console.warn = function (txt) {
    sendMessage({
        type: 'log',
        data: JSON.stringify(txt)
    })
}

console.error = function (txt) {
    sendMessage({
        type: 'log',
        data: JSON.stringify(txt)
    })
}

console.trace = function (txt) {
    sendMessage({
        type: 'log',
        data: JSON.stringify(txt)
    })
}

document.write = function (txt) {
    console.log(txt);
}

document.writeln = function (txt) {
    console.log(txt);
}

