let authid = "000000"
let projname = "";

let markers = [];

let settings = {};

window.addEventListener('load', () => {


    window.addEventListener("resize", (event) => {
        editorTS.layout();
        editorHTML.layout();
        editorCSS.layout();
        editorTSTemp.layout();
    });


    window.addEventListener("focusout", (event) => {
        if (authid != "000000") {
            let editorValue = editorTS.getValue();
            if (editorValue.indexOf("### KARA-Programm=ON") >= 0) {
                editorValue = editorValue.replace(/kara./g, "await kara.");
                editorValue = "async function __GO() {" + editorValue + "} __GO()";
            }
            sendMessage({
                type: 'savecloudproject',
                data: {
                    ts: editorTS.getValue(),
                    html: editorHTML.getValue(),
                    css: editorCSS.getValue(),
                    tstemp: editorTSTemp.getValue(),
                    ts2js: window.ts.transpile(editorTSTemp.getValue() + " " + editorValue)
                }
            });
        }
    });


    window.addEventListener("message", (event) => {

        if (event.data.type == "offline") {
            setOffline(event.data.data.offline);
        } else if (event.data.type == "cleareditor") {
            cleanEditors();
        } else if (event.data.type == "settings") {
            settings = event.data.data;
            updateSettings(settings);
        } else if (event.data.type == "guireloadrequest") {
            codeChanged()
            sendMessage({
                type: 'htmlmodified',
                data: editorHTML.getValue()
            });
            sendMessage({
                type: 'cssmodified',
                data: editorCSS.getValue()
            });
            /*sendMessage({
                type: 'tsmodified',
                data: window.ts.transpile(editorTSTemp.getValue() + " " + editorTS.getValue())
            });*/
        } else if (event.data.type == "projectloaded") {
            try {
                editorTS.setValue(event.data.data.ts);
                editorHTML.setValue(event.data.data.html);
                editorCSS.setValue(event.data.data.css);
                editorTSTemp.setValue(event.data.data.tstemp);

                setKIMenu();
            } catch (ex) {

            }
        } else if (event.data.type == "loginchanged") {
            authid = event.data.data;
            cleanEditors();
            prepareGUI();
        } else if (event.data.type == "projectnamechanged") {
            document.querySelector('.cloudhr').style.display = "block";
            projname = event.data.data;
            if (projname.length > 0) {
                document.querySelectorAll('.cloudproject').forEach(item => {
                    item.style.display = "block";
                })
                document.querySelectorAll('.localtocloudproject').forEach(item => {
                    item.style.display = "none";
                })
            } else {
                document.querySelectorAll('.cloudproject').forEach(item => {
                    item.style.display = "none";
                })
                document.querySelectorAll('.localtocloudproject').forEach(item => {
                    item.style.display = "block";
                })
            }

        } else if (event.data.type == "editorcontentrequest") {
            sendMessage({
                type: 'editorcontent',
                data: {
                    ts: editorTS.getValue(),
                    html: editorHTML.getValue(),
                    css: editorCSS.getValue(),
                    tstemp: editorTSTemp.getValue(),
                    ts2js: window.ts.transpile(editorTSTemp.getValue() + " " + editorTS.getValue())
                }
            });
        } else if (event.data.type == "highlightrangerequest") {
            highlightRange(event.data.data.split(","))
        } else if (event.data.type == "kisettingsresponse") {
            setKIData(event.data.data);
        } else {
            //console.log(event);
        }
    }, false);


    sendMessage = (json) => {
        parent.postMessage(json, "*");
    }


    document.querySelector('#mi_run').addEventListener('click', () => {

        const maxSeverity = markers.reduce((acc, val) => val.severity > acc ? val.severity : acc, 0);
        if (maxSeverity <= 1) {

            document.querySelector('#mi_run').style.color = '#0f0'

            if (projname != null && projname.length > 0) {
                let editorValue = editorTS.getValue();
                if (editorValue.indexOf("### KARA-Programm=ON") >= 0) {
                    editorValue = editorValue.replace(/kara./g, "await kara.");
                    editorValue = "async function __GO() {" + editorValue + "} __GO()";
                }
                sendMessage({
                    type: 'savecloudproject',
                    data: {
                        ts: editorTS.getValue(),
                        html: editorHTML.getValue(),
                        css: editorCSS.getValue(),
                        tstemp: editorTSTemp.getValue(),
                        ts2js: window.ts.transpile(editorTSTemp.getValue() + " " + editorValue)
                    },
                    option: {
                        checkUnderscore: false
                    }
                });
            }

            if (false) {
                //setting 'jsmode' is false
                sendMessage({
                    type: 'run',
                    data: window.ts.transpile(editorTSTemp.getValue().replace('let  alasql:any', '') + " " + prepare(editorTS.getValue().replace('let  alasql:any', '')))
                });
            } else {
                //setting 'jsmode' is true
                html = '    <style>';
                html += editorCSS.getValue()
                html += '    </style>';
                html += editorHTML.getValue();
                //html += "<script>" + window.ts.transpile(editorTSTemp.getValue() + " " + prepare(editorTS.getValue())) + "</script>";
                sendMessage({
                    type: 'run2',
                    data: {
                        'html': html,
                        'js': window.ts.transpile(editorTSTemp.getValue() + " " + prepare(editorTS.getValue()))
                    }
                });
            }
        }
    });





    document.querySelector('#mi_file_cloudsave').addEventListener('click', async (e) => {
        let editorValue = editorTS.getValue();
        if (editorValue.indexOf("### KARA-Programm=ON") >= 0) {
            editorValue = editorValue.replace(/kara./g, "await kara.");
            editorValue = "async function __GO() {" + editorValue + "} __GO()";
        }

        sendMessage({
            type: 'savecloudprojectForce',
            data: {
                ts: editorTS.getValue(),
                html: editorHTML.getValue(),
                css: editorCSS.getValue(),
                tstemp: editorTSTemp.getValue(),
                ts2js: window.ts.transpile(editorTSTemp.getValue() + " " + editorValue)
            },
            option: {
                checkUnderscore: false
            }
        });
    });

    document.querySelector('#mi_file_cloudcopy').addEventListener('click', async (e) => {
        sendMessage({
            type: 'copycloudproject',
            data: {
                ts: editorTS.getValue(),
                html: editorHTML.getValue(),
                css: editorCSS.getValue(),
                tstemp: editorTSTemp.getValue(),
                ts2js: window.ts.transpile(editorTSTemp.getValue() + " " + editorTS.getValue())
            }
        });
    });

    document.querySelector('#mi_file_save').addEventListener('click', async (e) => {
        sendMessage({
            type: 'saveproject',
            data: {
                ts: editorTS.getValue(),
                html: editorHTML.getValue(),
                css: editorCSS.getValue(),
                tstemp: editorTSTemp.getValue(),
                ts2js: window.ts.transpile(editorTSTemp.getValue() + " " + editorTS.getValue())
            }
        });
    });

    document.querySelector('#mi_file_load').addEventListener('click', async (e) => {
        sendMessage({
            type: 'loadproject',
            data: null
        });
    });

    document.querySelector('#mi_file_reset').addEventListener('click', async (e) => {
        cleanEditors();
    });

    /*
    document.querySelector('#mi_projectsettings').addEventListener('click', async (e) => {
        openProjectSettingsDialog();
    });
    */


    if (!window.showOpenFilePicker) {
        document.querySelectorAll('.nolocalfilesystem').forEach(item => {
            item.style.display = "none";
        })
    }




    // require is provided by loader.min.js.
    //require.config({ paths: { 'vs': 'https://cdnjs.cloudflare.com/ajax/libs/monaco-editor/0.26.1/min/vs' } });
    require.config({ paths: { 'vs': 'vs' } });
    require(["vs/editor/editor.main"], () => {

        editorTS = monaco.editor.create(document.getElementById('containerTS'), {
            value: `// ### Notieren Sie hier Ihren Typescript-Code. ###
//
//  -> Klicken Sie auf "Run", um den Code auszuführen.            
            
            


`,
            language: 'typescript',
            theme: 'vs-light',
            automaticLayout: true
        });

        editorHTML = monaco.editor.create(document.getElementById('containerHTML'), {
            value: `<!-- ### Notieren Sie hier Ihren HTML-Code ### -->


<h1>Wählen Sie ein Projekt aus der Projektliste</h1>
Weiter Informationen finden Sie im Projekt "_ Informationen und Zugangscode anfordern.tmyts"

            `,
            language: 'html',
            theme: 'vs-light',
            automaticLayout: true
        });

        editorCSS = monaco.editor.create(document.getElementById('containerCSS'), {
            value: `/* ### Notieren Sie hier Ihren CSS-Code ### */




            `,
            language: 'css',
            theme: 'vs-light',
            automaticLayout: true
        });

        editorTSTemp = monaco.editor.create(document.getElementById('containerTSTemp'), {
            value: `// ### Der folgende Typescript-Code sollte nicht verändert werden!  ###





            `,
            language: 'typescript',
            theme: 'vs-light',
            automaticLayout: true
        });

        editorHTML.onDidChangeModelContent((event) => {
            codeChanged()
            sendMessage({
                type: 'htmlmodified',
                data: editorHTML.getValue()
            });
        });

        editorCSS.onDidChangeModelContent((event) => {
            codeChanged()
            sendMessage({
                type: 'cssmodified',
                data: editorCSS.getValue()
            });
        });

        editorTS.onDidChangeModelContent((event) => {
            codeChanged()
            sendMessage({
                type: 'tsAllmodified',
                data: editorTSTemp.getValue() + editorTS.getValue()
            });
            sendMessage({
                type: 'tsmodified',
                data: editorTS.getValue()
            });
        });

        editorTSTemp.onDidChangeModelContent((event) => {
            codeChanged()
            setKIMenu()
            sendMessage({
                type: 'tsAllmodified',
                data: editorTSTemp.getValue() + editorTS.getValue()
            });
        });



        monaco.editor.onDidChangeMarkers(([uri]) => {
            markers = monaco.editor.getModelMarkers({ resource: uri })
            sendMessage({
                type: 'markerupdate',
                data: markers
            })

            const maxSeverity = markers.reduce((acc, val) => val.severity > acc ? val.severity : acc, 0);
            if (maxSeverity > 1) {
                document.querySelector('#mi_run').style.cursor = 'not-allowed'
                document.querySelector('#mi_run').style.color = '#ccc'
                document.querySelector('#mi_run').style.backgroundColor = "#600";
            } else {
                document.querySelector('#mi_run').style.cursor = 'pointer'
                document.querySelector('#mi_run').style.color = '#080'
                document.querySelector('#mi_run').style.backgroundColor = "#040";
            }
        });



        editorTS.onDidChangeCursorSelection((e) => {
            //console.log(JSON.stringify(e));
        });

        editorTSTemp.onDidChangeCursorSelection((e) => {
            //console.log(JSON.stringify(e));
        });

        this.editorTSTemp.updateOptions({ readOnly: true });

    });




    document.querySelector('#mi_typescript').addEventListener('click', () => {
        document.querySelector('#containerTS').style.display = 'block';
        document.querySelector('#containerHTML').style.display = 'none';
        document.querySelector('#containerCSS').style.display = 'none';
        document.querySelector('#containerTSTemp').style.display = 'none';
    })

    document.querySelector('#mi_html').addEventListener('click', () => {
        document.querySelector('#containerTS').style.display = 'none';
        document.querySelector('#containerHTML').style.display = 'block';
        document.querySelector('#containerCSS').style.display = 'none';
        document.querySelector('#containerTSTemp').style.display = 'none';
    })

    document.querySelector('#mi_css').addEventListener('click', () => {
        document.querySelector('#containerTS').style.display = 'none';
        document.querySelector('#containerHTML').style.display = 'none';
        document.querySelector('#containerCSS').style.display = 'block';
        document.querySelector('#containerTSTemp').style.display = 'none';
    })
    document.querySelector('#mi_typescript_template').addEventListener('click', () => {
        document.querySelector('#containerTS').style.display = 'none';
        document.querySelector('#containerHTML').style.display = 'none';
        document.querySelector('#containerCSS').style.display = 'none';
        document.querySelector('#containerTSTemp').style.display = 'block';
    })






    window.setTimeout(() => {
        sendMessage({
            type: 'htmlmodified',
            data: editorHTML.getValue()
        });

        sendMessage({
            type: 'htmlmodified',
            data: editorHTML.getValue()
        });

        sendMessage({
            type: 'tsAllmodified',
            data: editorTSTemp.getValue() + editorTS.getValue()
        });
    }, 100)

})


function setOffline(offline) {
    if (offline) {
        document.querySelectorAll('.onlineonly').forEach((elem) => {
            elem.style.visibility = 'hidden';
            elem.style.width = 0;
            elem.style.height = 0;
        })

        editorHTML.setValue("<!-- ### Notieren Sie hier Ihren HTML-Code ### -->");
    }
}



function codeChanged() {
    const maxSeverity = markers.reduce((acc, val) => val.severity > acc ? val.severity : acc, 0);
    if (maxSeverity < 1) {
        document.querySelector('#mi_run').style.color = '#080'
    }
}


function cleanEditors() {
    editorTS.setValue(`// ### Notieren Sie hier Ihren Typescript-Code. ###
//
//  -> Klicken Sie auf "Run", um den Code auszuführen.            


`);

    editorHTML.setValue(`<!-- ### Notieren Sie hier Ihren HTML-Code ### -->




`);

    editorCSS.setValue(`/* ### Notieren Sie hier Ihren CSS-Code ### */




        `);

    editorTSTemp.setValue(`// ### Der folgende Typescript-Code sollte nicht verändert werden!  ###

        
                    
        
    `);
    sendMessage({
        type: 'newprojectnamerequest',
        data: ''
    });
}




function prepareGUI() {
    if (authid.length < 10 /*&& authid != "000000"*/) {
        this.editorTSTemp.updateOptions({ readOnly: true });
        document.querySelectorAll('.teacher').forEach(el => {
            el.style.display = "none";
        })
    } else {
        this.editorTSTemp.updateOptions({ readOnly: false });
        document.querySelectorAll('.teacher').forEach(el => {
            el.style.display = "block";
        })
    }
}


function updateSettings(settings) {
    if (settings != null) {
        //nop
    }
}



function prepare(txt) {
    if (txt.indexOf("### KARA-Programm=ON") >= 0) {
        txt = "kara.hello();\n" + txt;
        txt = txt.replace(/kara./g, "await kara.");
        txt = "async function __GO() {" + txt + "} __GO()";
    }
    //console.log(txt)
    return txt;
}


function highlightRange(rangeArr) {
    if (rangeArr?.length == 4) {
        editorTS.setSelection(new monaco.Selection(1 * rangeArr[0], 1 * rangeArr[1], 1 * rangeArr[2], 1 * rangeArr[3]));
    }
}


function openProjectSettingsDialog() {
    sendMessage({
        type: 'modalsettings',
        data: ''
    });
}

function setKIMenu() {
    document.querySelector('#navbarKIMenu').innerHTML = "";
    tstemp = editorTSTemp.getValue();
    let i = 0;
    let menudefs = [];
    if (tstemp) {
        const idx1 = tstemp.indexOf("/*//-->KI-ITEMS");
        const idx2 = tstemp.indexOf("//<--KI-ITEMS*/", idx1 + 1);
        if (idx2 - idx1 > 3) {
            menudefs = JSON.parse(tstemp.substring(idx1 + "/*//-->KI-ITEMS".length, idx2));
        } else {
            menudefs = [];
        }

        if (settings && settings.freeKI == "true") {
            menudefs.push({
                "menutitle": "Frage die KI",
                "textsystem": "Deine Rolle ist die eines Lehrers. Erkläre Deine Antwort sehr ausführlich. Formatiere und strukturiere die Antwort als Text.",
                "textuser": "",
                "addcode": true,
                "replaceenitites": true,
                "editable": true
            })
        }

        menudefs.map(md => {
            document.querySelector('#navbarKIMenu').innerHTML += "<li id='kimi_" + i + "' class='dropdown-item'>" + md.menutitle + "</li>";
            i++;
        })
        i = 0;
        menudefs.map(md => {
            document.querySelector('#kimi_' + i).addEventListener('click', () => {
                try {
                    sendMessage({
                        type: 'kirequest',
                        data: md,
                        code: editorTS.getValue()
                    });
                } catch (ex) {
                    document.querySelector('#navbarKIMenu').innerHTML = "";
                }
            })
            i++;
        })
    }
    document.querySelector("#navbarKIMenu").append((new DOMParser().parseFromString('<li class="teacher"><hr class="dropdown-divider"></li>', 'text/html')).body.firstChild);
    document.querySelector("#navbarKIMenu").append((new DOMParser().parseFromString("<li class='teacher dropdown-item' id='kimenusettings'>KI-Verwaltung</li>", 'text/html')).body.firstChild);

    prepareGUI();

    document.querySelector('#kimenusettings').addEventListener('click', async (e) => {
        tstemp = editorTSTemp.getValue();
        sendMessage({
            type: 'kisettingsrequest',
            data: menudefs
        });

    });

}


function setKIData(data) {
    tstemp = editorTSTemp.getValue();

    const idx1 = tstemp.indexOf("/*//-->KI-ITEMS");
    const idx2 = tstemp.indexOf("//<--KI-ITEMS*/");
    if (idx1 >= 0 && idx2 >= idx1) {
        tstemp = tstemp.substring(0, idx1);
    }

    if (data && data.length > 0 && data[0].menutitle.length > 0) {
        tstemp = tstemp.trim() + "\n\n\n\n\n\n\n" + "/*//-->KI-ITEMS\n" + JSON.stringify(data.filter(item => item.menutitle != "Frage die KI")) + "\n//<--KI-ITEMS*/" + "\n//##############################################################\n//### Bitte nichts mehr unterhalb dieser Zeile schreiben!!! ###\n//#############################################################\n";
    }

    editorTSTemp.setValue(tstemp);
}
